Package org.kie.api.runtime

# Interface KieContainer

public interface KieContainer
A container for all the KieBases of a given KieModule

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `dispose()`
  Disposes all the KieSessions created in this KieContainer.
  `ClassLoader`
  `getClassLoader()`
  Returns the ClassLoader used by this KieContainer
  `KieBase`
  `getKieBase()`
  Returns the default KieBase in this KieContainer.
  `KieBase`
  `getKieBase(String kBaseName)`
  Returns the KieBase with the given name in this KieContainer.
  `KieBaseModel`
  `getKieBaseModel(String kBaseName)`
  Returns the KieBaseModel for the KieBase with the given name
  `Collection<String>`
  `getKieBaseNames()`
  Returns the names of all the KieBases available in this KieContainer
  `KieSessionConfiguration`
  `getKieSessionConfiguration()`
  Returns the KieSessionConfiguration of the default KieSession for this KieContainer
  `KieSessionConfiguration`
  `getKieSessionConfiguration(String kSessionName)`
  Returns the KieSessionConfiguration of the KieSession with the given name for this KieContainer
  `KieSessionModel`
  `getKieSessionModel(String kSessionName)`
  Returns the KieSessionModel for the KieSession with the given name
  `Collection<String>`
  `getKieSessionNamesInKieBase(String kBaseName)`
  Returns the names of all the KieSessions defined in this KieContainer for the given KieBase
  `ReleaseId`
  `getReleaseId()`
  Returns the ReleaseId of the KieModule wrapped by this KieContainer
  `KieBase`
  `newKieBase(String kBaseName, KieBaseConfiguration conf)`
  Creates a new KieBase with the given name using the given configuration.
  `KieBase`
  `newKieBase(KieBaseConfiguration conf)`
  Creates a new default KieBase using the given configuration.
  `KieSession`
  `newKieSession()`
  Creates the default KieSession for this KieContainer
  `KieSession`
  `newKieSession(String kSessionName)`
  Creates the KieSession with the given name for this KieContainer
  `KieSession`
  `newKieSession(String kSessionName, Environment environment)`
  Creates the KieSession with the given name for this KieContainer using the given Environment
  `KieSession`
  `newKieSession(String kSessionName, Environment environment, KieSessionConfiguration conf)`
  Creates the KieSession with the given name for this KieContainer using the given Environment and configuration
  `KieSession`
  `newKieSession(String kSessionName, KieSessionConfiguration conf)`
  Creates the KieSession with the given name for this KieContainer with the given configuration
  `KieSession`
  `newKieSession(Environment environment)`
  Creates the default `KieSession` for this KieContainer using the given Environment
  `KieSession`
  `newKieSession(Environment environment, KieSessionConfiguration conf)`
  Creates the default KieSession for this KieContainer with the given configuration and Environment
  `KieSession`
  `newKieSession(KieSessionConfiguration conf)`
  Creates the default KieSession for this KieContainer with the given configuration
  `KieContainerSessionsPool`
  `newKieSessionsPool(int initialSize)`
  Creates a new `KieContainerSessionsPool` storing the sessions created from this KieContainer.
  `StatelessKieSession`
  `newStatelessKieSession()`
  Creates the default StatelessKieSession for this KieContainer
  `StatelessKieSession`
  `newStatelessKieSession(String kSessionName)`
  Creates the StatelessKieSession with the given name for this KieContainer
  `StatelessKieSession`
  `newStatelessKieSession(String kSessionName, KieSessionConfiguration conf)`
  Creates the StatelessKieSession with the given name for this KieContainer using the given configuration
  `StatelessKieSession`
  `newStatelessKieSession(KieSessionConfiguration conf)`
  Creates the default StatelessKieSession for this KieContainer using the given configuration
  `Results`
  `updateToVersion(ReleaseId version)`
  Updates this KieContainer to a KieModule with the given fixed ReleaseId (e.g.
  `Results`
  `verify()`
  Builds all the KieBase in the KieModule wrapped by this KieContainer and return te Results of this building process
  `Results`
  `verify(String... kBaseNames)`
  Builds the KieBases with the given name(s) in the KieModule wrapped by this KieContainer and return the Results of this building process

- ## Method Details

  - ### dispose

    void dispose()
    Disposes all the KieSessions created in this KieContainer. If this KieContainer's containerId was registered with the KieServices, it will free the ID and unregister it from KieServices. If existing, dispose all JMX resources associated with this KieContainer.

  - ### getReleaseId

    ReleaseId getReleaseId()
    Returns the ReleaseId of the KieModule wrapped by this KieContainer

  - ### verify

    Results verify()
    Builds all the KieBase in the KieModule wrapped by this KieContainer and return te Results of this building process

  - ### verify

    Results verify(String... kBaseNames)
    Builds the KieBases with the given name(s) in the KieModule wrapped by this KieContainer and return the Results of this building process

  - ### updateToVersion

    Results updateToVersion(ReleaseId version)
    Updates this KieContainer to a KieModule with the given fixed ReleaseId (e.g. com.acme:acme-rules:1.0.0.Final). The new release id should not contain the placeholder versions like LATEST or RELEASE as that will not work as expected. The container will not automatically find and resolve the "latest" version and will keep the old one in place.

  - ### getKieBaseNames

    Collection<String> getKieBaseNames()
    Returns the names of all the KieBases available in this KieContainer

  - ### getKieSessionNamesInKieBase

    Collection<String> getKieSessionNamesInKieBase(String kBaseName)
    Returns the names of all the KieSessions defined in this KieContainer for the given KieBase

  - ### getKieBase

    KieBase getKieBase()
    Returns the default KieBase in this KieContainer. The returned KieBase will be managed by this KieContainer and then it will be updated when the KieContainer itself will be updated to a newer version of the KieModule.
    Throws:
      `RuntimeException` - if this KieContainer doesn't have any default KieBase
    See Also:
      - `KieBaseModel.setDefault(boolean)`

  - ### getKieBase

    KieBase getKieBase(String kBaseName)
    Returns the KieBase with the given name in this KieContainer. The returned KieBase will be managed by this KieContainer and then it will be updated when the KieContainer itself will be updated to a newer version of the KieModule.
    Throws:
      `RuntimeException` - if this KieContainer doesn't have any KieBase with the given name

  - ### newKieBase

    KieBase newKieBase(KieBaseConfiguration conf)
    Creates a new default KieBase using the given configuration. The returned KieBase will be detached from this KieContainer and then will NOT be updated when the KieContainer itself will be updated to a newer version of the KieModule.
    Throws:
      `RuntimeException` - if this KieContainer doesn't have any default KieBase
    See Also:
      - `KieBaseModel.setDefault(boolean)`

  - ### newKieBase

    KieBase newKieBase(String kBaseName, KieBaseConfiguration conf)
    Creates a new KieBase with the given name using the given configuration. The returned KieBase will be detached from this KieContainer and then will NOT be updated when the KieContainer itself will be updated to a newer version of the KieModule.
    Throws:
      `RuntimeException` - if this KieContainer doesn't have any KieBase with the given name

  - ### newKieSessionsPool

    KieContainerSessionsPool newKieSessionsPool(int initialSize)
    Creates a new `KieContainerSessionsPool` storing the sessions created from this KieContainer. Don't forget to `KieSessionsPool.shutdown()` the pool when you are done.
    Parameters:
      `initialSize` - the initial size of sessions in the pool
    Returns:
      created `KieContainerSessionsPool`

  - ### newKieSession

    KieSession newKieSession()
    Creates the default KieSession for this KieContainer
    Throws:
      `RuntimeException` - if this KieContainer doesn't have any default KieSession
    See Also:
      - `KieSessionModel.setDefault(boolean)`

  - ### newKieSession

    KieSession newKieSession(KieSessionConfiguration conf)
    Creates the default KieSession for this KieContainer with the given configuration
    Throws:
      `RuntimeException` - if this KieContainer doesn't have any default KieSession
    See Also:
      - `KieSessionModel.setDefault(boolean)`

  - ### newKieSession

    KieSession newKieSession(Environment environment)
    Creates the default `KieSession` for this KieContainer using the given Environment
    Throws:
      `RuntimeException` - if this KieContainer doesn't have any default KieSession
    See Also:
      - `KieSessionModel.setDefault(boolean)`

  - ### newKieSession

    KieSession newKieSession(Environment environment, KieSessionConfiguration conf)
    Creates the default KieSession for this KieContainer with the given configuration and Environment
    Throws:
      `RuntimeException` - if this KieContainer doesn't have any default KieSession
    See Also:
      - `KieSessionModel.setDefault(boolean)`

  - ### newKieSession

    KieSession newKieSession(String kSessionName)
    Creates the KieSession with the given name for this KieContainer
    Throws:
      `RuntimeException` - if this KieContainer doesn't have any KieSession with the given name

  - ### newKieSession

    KieSession newKieSession(String kSessionName, Environment environment)
    Creates the KieSession with the given name for this KieContainer using the given Environment
    Throws:
      `RuntimeException` - if this KieContainer doesn't have any KieSession with the given name

  - ### newKieSession

    KieSession newKieSession(String kSessionName, KieSessionConfiguration conf)
    Creates the KieSession with the given name for this KieContainer with the given configuration
    Throws:
      `RuntimeException` - if this KieContainer doesn't have any KieSession with the given name

  - ### newKieSession

    KieSession newKieSession(String kSessionName, Environment environment, KieSessionConfiguration conf)
    Creates the KieSession with the given name for this KieContainer using the given Environment and configuration
    Throws:
      `RuntimeException` - if this KieContainer doesn't have any KieSession with the given name

  - ### newStatelessKieSession

    StatelessKieSession newStatelessKieSession()
    Creates the default StatelessKieSession for this KieContainer
    Throws:
      `RuntimeException` - if this KieContainer doesn't have any default StatelessKieSession
    See Also:
      - `KieSessionModel.setDefault(boolean)`

  - ### newStatelessKieSession

    StatelessKieSession newStatelessKieSession(KieSessionConfiguration conf)
    Creates the default StatelessKieSession for this KieContainer using the given configuration
    Throws:
      `RuntimeException` - if this KieContainer doesn't have any default StatelessKieSession
    See Also:
      - `KieSessionModel.setDefault(boolean)`

  - ### newStatelessKieSession

    StatelessKieSession newStatelessKieSession(String kSessionName)
    Creates the StatelessKieSession with the given name for this KieContainer
    Throws:
      `RuntimeException` - if this KieContainer doesn't have any StatelessKieSession with the given name

  - ### newStatelessKieSession

    StatelessKieSession newStatelessKieSession(String kSessionName, KieSessionConfiguration conf)
    Creates the StatelessKieSession with the given name for this KieContainer using the given configuration
    Throws:
      `RuntimeException` - if this KieContainer doesn't have any StatelessKieSession with the given name

  - ### getClassLoader

    ClassLoader getClassLoader()
    Returns the ClassLoader used by this KieContainer

  - ### getKieSessionConfiguration

    KieSessionConfiguration getKieSessionConfiguration()
    Returns the KieSessionConfiguration of the default KieSession for this KieContainer

  - ### getKieSessionConfiguration

    KieSessionConfiguration getKieSessionConfiguration(String kSessionName)
    Returns the KieSessionConfiguration of the KieSession with the given name for this KieContainer

  - ### getKieBaseModel

    KieBaseModel getKieBaseModel(String kBaseName)
    Returns the KieBaseModel for the KieBase with the given name

  - ### getKieSessionModel

    KieSessionModel getKieSessionModel(String kSessionName)
    Returns the KieSessionModel for the KieSession with the given name